# RUN: llvm-mc -triple x86_64 -show-encoding -x86-asm-syntax=intel -output-asm-variant=1 %s | FileCheck %s

# CHECK: {evex}	and	bl, 123
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0x80,0xe3,0x7b]
         {evex}	and	bl, 123
# CHECK: {nf}	and	bl, 123
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0x80,0xe3,0x7b]
         {nf}	and	bl, 123
# CHECK: and	cl, bl, 123
# CHECK: encoding: [0x62,0xf4,0x74,0x18,0x80,0xe3,0x7b]
         and	cl, bl, 123
# CHECK: {nf}	and	cl, bl, 123
# CHECK: encoding: [0x62,0xf4,0x74,0x1c,0x80,0xe3,0x7b]
         {nf}	and	cl, bl, 123
# CHECK: {evex}	and	dx, 123
# CHECK: encoding: [0x62,0xf4,0x7d,0x08,0x83,0xe2,0x7b]
         {evex}	and	dx, 123
# CHECK: {nf}	and	dx, 123
# CHECK: encoding: [0x62,0xf4,0x7d,0x0c,0x83,0xe2,0x7b]
         {nf}	and	dx, 123
# CHECK: and	ax, dx, 123
# CHECK: encoding: [0x62,0xf4,0x7d,0x18,0x83,0xe2,0x7b]
         and	ax, dx, 123
# CHECK: {nf}	and	ax, dx, 123
# CHECK: encoding: [0x62,0xf4,0x7d,0x1c,0x83,0xe2,0x7b]
         {nf}	and	ax, dx, 123
# CHECK: {evex}	and	ecx, 123
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0x83,0xe1,0x7b]
         {evex}	and	ecx, 123
# CHECK: {nf}	and	ecx, 123
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0x83,0xe1,0x7b]
         {nf}	and	ecx, 123
# CHECK: and	edx, ecx, 123
# CHECK: encoding: [0x62,0xf4,0x6c,0x18,0x83,0xe1,0x7b]
         and	edx, ecx, 123
# CHECK: {nf}	and	edx, ecx, 123
# CHECK: encoding: [0x62,0xf4,0x6c,0x1c,0x83,0xe1,0x7b]
         {nf}	and	edx, ecx, 123
# CHECK: {evex}	and	r9, 123
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0x83,0xe1,0x7b]
         {evex}	and	r9, 123
# CHECK: {nf}	and	r9, 123
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0x83,0xe1,0x7b]
         {nf}	and	r9, 123
# CHECK: and	r15, r9, 123
# CHECK: encoding: [0x62,0xd4,0x84,0x18,0x83,0xe1,0x7b]
         and	r15, r9, 123
# CHECK: {nf}	and	r15, r9, 123
# CHECK: encoding: [0x62,0xd4,0x84,0x1c,0x83,0xe1,0x7b]
         {nf}	and	r15, r9, 123
# CHECK: {evex}	and	byte ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0x80,0xa4,0x80,0x23,0x01,0x00,0x00,0x7b]
         {evex}	and	byte ptr [r8 + 4*rax + 291], 123
# CHECK: {nf}	and	byte ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0x80,0xa4,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	and	byte ptr [r8 + 4*rax + 291], 123
# CHECK: and	bl, byte ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0x64,0x18,0x80,0xa4,0x80,0x23,0x01,0x00,0x00,0x7b]
         and	bl, byte ptr [r8 + 4*rax + 291], 123
# CHECK: {nf}	and	bl, byte ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0x64,0x1c,0x80,0xa4,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	and	bl, byte ptr [r8 + 4*rax + 291], 123
# CHECK: {evex}	and	word ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0x7d,0x08,0x83,0xa4,0x80,0x23,0x01,0x00,0x00,0x7b]
         {evex}	and	word ptr [r8 + 4*rax + 291], 123
# CHECK: {nf}	and	word ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0x7d,0x0c,0x83,0xa4,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	and	word ptr [r8 + 4*rax + 291], 123
# CHECK: and	dx, word ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0x6d,0x18,0x83,0xa4,0x80,0x23,0x01,0x00,0x00,0x7b]
         and	dx, word ptr [r8 + 4*rax + 291], 123
# CHECK: {nf}	and	dx, word ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0x6d,0x1c,0x83,0xa4,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	and	dx, word ptr [r8 + 4*rax + 291], 123
# CHECK: {evex}	and	dword ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0x83,0xa4,0x80,0x23,0x01,0x00,0x00,0x7b]
         {evex}	and	dword ptr [r8 + 4*rax + 291], 123
# CHECK: {nf}	and	dword ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0x83,0xa4,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	and	dword ptr [r8 + 4*rax + 291], 123
# CHECK: and	ecx, dword ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0x74,0x18,0x83,0xa4,0x80,0x23,0x01,0x00,0x00,0x7b]
         and	ecx, dword ptr [r8 + 4*rax + 291], 123
# CHECK: {nf}	and	ecx, dword ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0x74,0x1c,0x83,0xa4,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	and	ecx, dword ptr [r8 + 4*rax + 291], 123
# CHECK: {evex}	and	qword ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0x83,0xa4,0x80,0x23,0x01,0x00,0x00,0x7b]
         {evex}	and	qword ptr [r8 + 4*rax + 291], 123
# CHECK: {nf}	and	qword ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0x83,0xa4,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	and	qword ptr [r8 + 4*rax + 291], 123
# CHECK: and	r9, qword ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0xb4,0x18,0x83,0xa4,0x80,0x23,0x01,0x00,0x00,0x7b]
         and	r9, qword ptr [r8 + 4*rax + 291], 123
# CHECK: {nf}	and	r9, qword ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0xb4,0x1c,0x83,0xa4,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	and	r9, qword ptr [r8 + 4*rax + 291], 123
# CHECK: {evex}	and	dx, 1234
# CHECK: encoding: [0x62,0xf4,0x7d,0x08,0x81,0xe2,0xd2,0x04]
         {evex}	and	dx, 1234
# CHECK: {nf}	and	dx, 1234
# CHECK: encoding: [0x62,0xf4,0x7d,0x0c,0x81,0xe2,0xd2,0x04]
         {nf}	and	dx, 1234
# CHECK: and	ax, dx, 1234
# CHECK: encoding: [0x62,0xf4,0x7d,0x18,0x81,0xe2,0xd2,0x04]
         and	ax, dx, 1234
# CHECK: {nf}	and	ax, dx, 1234
# CHECK: encoding: [0x62,0xf4,0x7d,0x1c,0x81,0xe2,0xd2,0x04]
         {nf}	and	ax, dx, 1234
# CHECK: {evex}	and	word ptr [r8 + 4*rax + 291], 1234
# CHECK: encoding: [0x62,0xd4,0x7d,0x08,0x81,0xa4,0x80,0x23,0x01,0x00,0x00,0xd2,0x04]
         {evex}	and	word ptr [r8 + 4*rax + 291], 1234
# CHECK: {nf}	and	word ptr [r8 + 4*rax + 291], 1234
# CHECK: encoding: [0x62,0xd4,0x7d,0x0c,0x81,0xa4,0x80,0x23,0x01,0x00,0x00,0xd2,0x04]
         {nf}	and	word ptr [r8 + 4*rax + 291], 1234
# CHECK: and	dx, word ptr [r8 + 4*rax + 291], 1234
# CHECK: encoding: [0x62,0xd4,0x6d,0x18,0x81,0xa4,0x80,0x23,0x01,0x00,0x00,0xd2,0x04]
         and	dx, word ptr [r8 + 4*rax + 291], 1234
# CHECK: {nf}	and	dx, word ptr [r8 + 4*rax + 291], 1234
# CHECK: encoding: [0x62,0xd4,0x6d,0x1c,0x81,0xa4,0x80,0x23,0x01,0x00,0x00,0xd2,0x04]
         {nf}	and	dx, word ptr [r8 + 4*rax + 291], 1234
# CHECK: {evex}	and	ecx, 123456
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0x81,0xe1,0x40,0xe2,0x01,0x00]
         {evex}	and	ecx, 123456
# CHECK: {nf}	and	ecx, 123456
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0x81,0xe1,0x40,0xe2,0x01,0x00]
         {nf}	and	ecx, 123456
# CHECK: and	edx, ecx, 123456
# CHECK: encoding: [0x62,0xf4,0x6c,0x18,0x81,0xe1,0x40,0xe2,0x01,0x00]
         and	edx, ecx, 123456
# CHECK: {nf}	and	edx, ecx, 123456
# CHECK: encoding: [0x62,0xf4,0x6c,0x1c,0x81,0xe1,0x40,0xe2,0x01,0x00]
         {nf}	and	edx, ecx, 123456
# CHECK: {evex}	and	r9, 123456
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0x81,0xe1,0x40,0xe2,0x01,0x00]
         {evex}	and	r9, 123456
# CHECK: {nf}	and	r9, 123456
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0x81,0xe1,0x40,0xe2,0x01,0x00]
         {nf}	and	r9, 123456
# CHECK: and	r15, r9, 123456
# CHECK: encoding: [0x62,0xd4,0x84,0x18,0x81,0xe1,0x40,0xe2,0x01,0x00]
         and	r15, r9, 123456
# CHECK: {nf}	and	r15, r9, 123456
# CHECK: encoding: [0x62,0xd4,0x84,0x1c,0x81,0xe1,0x40,0xe2,0x01,0x00]
         {nf}	and	r15, r9, 123456
# CHECK: {evex}	and	dword ptr [r8 + 4*rax + 291], 123456
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0x81,0xa4,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         {evex}	and	dword ptr [r8 + 4*rax + 291], 123456
# CHECK: {nf}	and	dword ptr [r8 + 4*rax + 291], 123456
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0x81,0xa4,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         {nf}	and	dword ptr [r8 + 4*rax + 291], 123456
# CHECK: and	ecx, dword ptr [r8 + 4*rax + 291], 123456
# CHECK: encoding: [0x62,0xd4,0x74,0x18,0x81,0xa4,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         and	ecx, dword ptr [r8 + 4*rax + 291], 123456
# CHECK: {nf}	and	ecx, dword ptr [r8 + 4*rax + 291], 123456
# CHECK: encoding: [0x62,0xd4,0x74,0x1c,0x81,0xa4,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         {nf}	and	ecx, dword ptr [r8 + 4*rax + 291], 123456
# CHECK: {evex}	and	qword ptr [r8 + 4*rax + 291], 123456
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0x81,0xa4,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         {evex}	and	qword ptr [r8 + 4*rax + 291], 123456
# CHECK: {nf}	and	qword ptr [r8 + 4*rax + 291], 123456
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0x81,0xa4,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         {nf}	and	qword ptr [r8 + 4*rax + 291], 123456
# CHECK: and	r9, qword ptr [r8 + 4*rax + 291], 123456
# CHECK: encoding: [0x62,0xd4,0xb4,0x18,0x81,0xa4,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         and	r9, qword ptr [r8 + 4*rax + 291], 123456
# CHECK: {nf}	and	r9, qword ptr [r8 + 4*rax + 291], 123456
# CHECK: encoding: [0x62,0xd4,0xb4,0x1c,0x81,0xa4,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         {nf}	and	r9, qword ptr [r8 + 4*rax + 291], 123456
# CHECK: {evex}	and	cl, bl
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0x20,0xd9]
         {evex}	and	cl, bl
# CHECK: {nf}	and	cl, bl
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0x20,0xd9]
         {nf}	and	cl, bl
# CHECK: and	r8b, cl, bl
# CHECK: encoding: [0x62,0xf4,0x3c,0x18,0x20,0xd9]
         and	r8b, cl, bl
# CHECK: {nf}	and	r8b, cl, bl
# CHECK: encoding: [0x62,0xf4,0x3c,0x1c,0x20,0xd9]
         {nf}	and	r8b, cl, bl
# CHECK: {evex}	and	byte ptr [r8 + 4*rax + 291], bl
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0x20,0x9c,0x80,0x23,0x01,0x00,0x00]
         {evex}	and	byte ptr [r8 + 4*rax + 291], bl
# CHECK: {nf}	and	byte ptr [r8 + 4*rax + 291], bl
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0x20,0x9c,0x80,0x23,0x01,0x00,0x00]
         {nf}	and	byte ptr [r8 + 4*rax + 291], bl
# CHECK: and	cl, byte ptr [r8 + 4*rax + 291], bl
# CHECK: encoding: [0x62,0xd4,0x74,0x18,0x20,0x9c,0x80,0x23,0x01,0x00,0x00]
         and	cl, byte ptr [r8 + 4*rax + 291], bl
# CHECK: {nf}	and	cl, byte ptr [r8 + 4*rax + 291], bl
# CHECK: encoding: [0x62,0xd4,0x74,0x1c,0x20,0x9c,0x80,0x23,0x01,0x00,0x00]
         {nf}	and	cl, byte ptr [r8 + 4*rax + 291], bl
# CHECK: {evex}	and	ax, dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x08,0x21,0xd0]
         {evex}	and	ax, dx
# CHECK: {nf}	and	ax, dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x0c,0x21,0xd0]
         {nf}	and	ax, dx
# CHECK: and	r9w, ax, dx
# CHECK: encoding: [0x62,0xf4,0x35,0x18,0x21,0xd0]
         and	r9w, ax, dx
# CHECK: {nf}	and	r9w, ax, dx
# CHECK: encoding: [0x62,0xf4,0x35,0x1c,0x21,0xd0]
         {nf}	and	r9w, ax, dx
# CHECK: {evex}	and	word ptr [r8 + 4*rax + 291], dx
# CHECK: encoding: [0x62,0xd4,0x7d,0x08,0x21,0x94,0x80,0x23,0x01,0x00,0x00]
         {evex}	and	word ptr [r8 + 4*rax + 291], dx
# CHECK: {nf}	and	word ptr [r8 + 4*rax + 291], dx
# CHECK: encoding: [0x62,0xd4,0x7d,0x0c,0x21,0x94,0x80,0x23,0x01,0x00,0x00]
         {nf}	and	word ptr [r8 + 4*rax + 291], dx
# CHECK: and	ax, word ptr [r8 + 4*rax + 291], dx
# CHECK: encoding: [0x62,0xd4,0x7d,0x18,0x21,0x94,0x80,0x23,0x01,0x00,0x00]
         and	ax, word ptr [r8 + 4*rax + 291], dx
# CHECK: {nf}	and	ax, word ptr [r8 + 4*rax + 291], dx
# CHECK: encoding: [0x62,0xd4,0x7d,0x1c,0x21,0x94,0x80,0x23,0x01,0x00,0x00]
         {nf}	and	ax, word ptr [r8 + 4*rax + 291], dx
# CHECK: {evex}	and	edx, ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0x21,0xca]
         {evex}	and	edx, ecx
# CHECK: {nf}	and	edx, ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0x21,0xca]
         {nf}	and	edx, ecx
# CHECK: and	r10d, edx, ecx
# CHECK: encoding: [0x62,0xf4,0x2c,0x18,0x21,0xca]
         and	r10d, edx, ecx
# CHECK: {nf}	and	r10d, edx, ecx
# CHECK: encoding: [0x62,0xf4,0x2c,0x1c,0x21,0xca]
         {nf}	and	r10d, edx, ecx
# CHECK: {evex}	and	dword ptr [r8 + 4*rax + 291], ecx
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0x21,0x8c,0x80,0x23,0x01,0x00,0x00]
         {evex}	and	dword ptr [r8 + 4*rax + 291], ecx
# CHECK: {nf}	and	dword ptr [r8 + 4*rax + 291], ecx
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0x21,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	and	dword ptr [r8 + 4*rax + 291], ecx
# CHECK: and	edx, dword ptr [r8 + 4*rax + 291], ecx
# CHECK: encoding: [0x62,0xd4,0x6c,0x18,0x21,0x8c,0x80,0x23,0x01,0x00,0x00]
         and	edx, dword ptr [r8 + 4*rax + 291], ecx
# CHECK: {nf}	and	edx, dword ptr [r8 + 4*rax + 291], ecx
# CHECK: encoding: [0x62,0xd4,0x6c,0x1c,0x21,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	and	edx, dword ptr [r8 + 4*rax + 291], ecx
# CHECK: {evex}	and	r15, r9
# CHECK: encoding: [0x62,0x54,0xfc,0x08,0x21,0xcf]
         {evex}	and	r15, r9
# CHECK: {nf}	and	r15, r9
# CHECK: encoding: [0x62,0x54,0xfc,0x0c,0x21,0xcf]
         {nf}	and	r15, r9
# CHECK: and	r11, r15, r9
# CHECK: encoding: [0x62,0x54,0xa4,0x18,0x21,0xcf]
         and	r11, r15, r9
# CHECK: {nf}	and	r11, r15, r9
# CHECK: encoding: [0x62,0x54,0xa4,0x1c,0x21,0xcf]
         {nf}	and	r11, r15, r9
# CHECK: {evex}	and	qword ptr [r8 + 4*rax + 291], r9
# CHECK: encoding: [0x62,0x54,0xfc,0x08,0x21,0x8c,0x80,0x23,0x01,0x00,0x00]
         {evex}	and	qword ptr [r8 + 4*rax + 291], r9
# CHECK: {nf}	and	qword ptr [r8 + 4*rax + 291], r9
# CHECK: encoding: [0x62,0x54,0xfc,0x0c,0x21,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	and	qword ptr [r8 + 4*rax + 291], r9
# CHECK: and	r15, qword ptr [r8 + 4*rax + 291], r9
# CHECK: encoding: [0x62,0x54,0x84,0x18,0x21,0x8c,0x80,0x23,0x01,0x00,0x00]
         and	r15, qword ptr [r8 + 4*rax + 291], r9
# CHECK: {nf}	and	r15, qword ptr [r8 + 4*rax + 291], r9
# CHECK: encoding: [0x62,0x54,0x84,0x1c,0x21,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	and	r15, qword ptr [r8 + 4*rax + 291], r9
# CHECK: {evex}	and	bl, byte ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0x22,0x9c,0x80,0x23,0x01,0x00,0x00]
         {evex}	and	bl, byte ptr [r8 + 4*rax + 291]
# CHECK: {nf}	and	bl, byte ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0x22,0x9c,0x80,0x23,0x01,0x00,0x00]
         {nf}	and	bl, byte ptr [r8 + 4*rax + 291]
# CHECK: and	cl, bl, byte ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x74,0x18,0x22,0x9c,0x80,0x23,0x01,0x00,0x00]
         and	cl, bl, byte ptr [r8 + 4*rax + 291]
# CHECK: {nf}	and	cl, bl, byte ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x74,0x1c,0x22,0x9c,0x80,0x23,0x01,0x00,0x00]
         {nf}	and	cl, bl, byte ptr [r8 + 4*rax + 291]
# CHECK: {evex}	and	dx, word ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x7d,0x08,0x23,0x94,0x80,0x23,0x01,0x00,0x00]
         {evex}	and	dx, word ptr [r8 + 4*rax + 291]
# CHECK: {nf}	and	dx, word ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x7d,0x0c,0x23,0x94,0x80,0x23,0x01,0x00,0x00]
         {nf}	and	dx, word ptr [r8 + 4*rax + 291]
# CHECK: and	ax, dx, word ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x7d,0x18,0x23,0x94,0x80,0x23,0x01,0x00,0x00]
         and	ax, dx, word ptr [r8 + 4*rax + 291]
# CHECK: {nf}	and	ax, dx, word ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x7d,0x1c,0x23,0x94,0x80,0x23,0x01,0x00,0x00]
         {nf}	and	ax, dx, word ptr [r8 + 4*rax + 291]
# CHECK: {evex}	and	ecx, dword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0x23,0x8c,0x80,0x23,0x01,0x00,0x00]
         {evex}	and	ecx, dword ptr [r8 + 4*rax + 291]
# CHECK: {nf}	and	ecx, dword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0x23,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	and	ecx, dword ptr [r8 + 4*rax + 291]
# CHECK: and	edx, ecx, dword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x6c,0x18,0x23,0x8c,0x80,0x23,0x01,0x00,0x00]
         and	edx, ecx, dword ptr [r8 + 4*rax + 291]
# CHECK: {nf}	and	edx, ecx, dword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x6c,0x1c,0x23,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	and	edx, ecx, dword ptr [r8 + 4*rax + 291]
# CHECK: {evex}	and	r9, qword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0x54,0xfc,0x08,0x23,0x8c,0x80,0x23,0x01,0x00,0x00]
         {evex}	and	r9, qword ptr [r8 + 4*rax + 291]
# CHECK: {nf}	and	r9, qword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0x54,0xfc,0x0c,0x23,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	and	r9, qword ptr [r8 + 4*rax + 291]
# CHECK: and	r15, r9, qword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0x54,0x84,0x18,0x23,0x8c,0x80,0x23,0x01,0x00,0x00]
         and	r15, r9, qword ptr [r8 + 4*rax + 291]
# CHECK: {nf}	and	r15, r9, qword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0x54,0x84,0x1c,0x23,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	and	r15, r9, qword ptr [r8 + 4*rax + 291]
