# RUN: llvm-mc -triple x86_64 -show-encoding %s | FileCheck %s
# RUN: not llvm-mc -triple i386 -show-encoding %s 2>&1 | FileCheck %s --check-prefix=ERROR

# ERROR-COUNT-32: error:
# ERROR-NOT: error:
# CHECK: {evex}	negb	%bl
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0xf6,0xdb]
         {evex}	negb	%bl
# CHECK: {nf}	negb	%bl
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0xf6,0xdb]
         {nf}	negb	%bl
# CHECK: negb	%bl, %bl
# CHECK: encoding: [0x62,0xf4,0x64,0x18,0xf6,0xdb]
         negb	%bl, %bl
# CHECK: {nf}	negb	%bl, %bl
# CHECK: encoding: [0x62,0xf4,0x64,0x1c,0xf6,0xdb]
         {nf}	negb	%bl, %bl
# CHECK: {evex}	negw	%dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x08,0xf7,0xda]
         {evex}	negw	%dx
# CHECK: {nf}	negw	%dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x0c,0xf7,0xda]
         {nf}	negw	%dx
# CHECK: negw	%dx, %dx
# CHECK: encoding: [0x62,0xf4,0x6d,0x18,0xf7,0xda]
         negw	%dx, %dx
# CHECK: {nf}	negw	%dx, %dx
# CHECK: encoding: [0x62,0xf4,0x6d,0x1c,0xf7,0xda]
         {nf}	negw	%dx, %dx
# CHECK: {evex}	negl	%ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0xf7,0xd9]
         {evex}	negl	%ecx
# CHECK: {nf}	negl	%ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0xf7,0xd9]
         {nf}	negl	%ecx
# CHECK: negl	%ecx, %ecx
# CHECK: encoding: [0x62,0xf4,0x74,0x18,0xf7,0xd9]
         negl	%ecx, %ecx
# CHECK: {nf}	negl	%ecx, %ecx
# CHECK: encoding: [0x62,0xf4,0x74,0x1c,0xf7,0xd9]
         {nf}	negl	%ecx, %ecx
# CHECK: {evex}	negq	%r9
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0xf7,0xd9]
         {evex}	negq	%r9
# CHECK: {nf}	negq	%r9
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0xf7,0xd9]
         {nf}	negq	%r9
# CHECK: negq	%r9, %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x18,0xf7,0xd9]
         negq	%r9, %r9
# CHECK: {nf}	negq	%r9, %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x1c,0xf7,0xd9]
         {nf}	negq	%r9, %r9
# CHECK: {evex}	negb	291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0xf6,0x9c,0x80,0x23,0x01,0x00,0x00]
         {evex}	negb	291(%r8,%rax,4)
# CHECK: {nf}	negb	291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0xf6,0x9c,0x80,0x23,0x01,0x00,0x00]
         {nf}	negb	291(%r8,%rax,4)
# CHECK: negb	291(%r8,%rax,4), %bl
# CHECK: encoding: [0x62,0xd4,0x64,0x18,0xf6,0x9c,0x80,0x23,0x01,0x00,0x00]
         negb	291(%r8,%rax,4), %bl
# CHECK: {nf}	negb	291(%r8,%rax,4), %bl
# CHECK: encoding: [0x62,0xd4,0x64,0x1c,0xf6,0x9c,0x80,0x23,0x01,0x00,0x00]
         {nf}	negb	291(%r8,%rax,4), %bl
# CHECK: {evex}	negw	291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x08,0xf7,0x9c,0x80,0x23,0x01,0x00,0x00]
         {evex}	negw	291(%r8,%rax,4)
# CHECK: {nf}	negw	291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x0c,0xf7,0x9c,0x80,0x23,0x01,0x00,0x00]
         {nf}	negw	291(%r8,%rax,4)
# CHECK: negw	291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x6d,0x18,0xf7,0x9c,0x80,0x23,0x01,0x00,0x00]
         negw	291(%r8,%rax,4), %dx
# CHECK: {nf}	negw	291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x6d,0x1c,0xf7,0x9c,0x80,0x23,0x01,0x00,0x00]
         {nf}	negw	291(%r8,%rax,4), %dx
# CHECK: {evex}	negl	291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0xf7,0x9c,0x80,0x23,0x01,0x00,0x00]
         {evex}	negl	291(%r8,%rax,4)
# CHECK: {nf}	negl	291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0xf7,0x9c,0x80,0x23,0x01,0x00,0x00]
         {nf}	negl	291(%r8,%rax,4)
# CHECK: negl	291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x74,0x18,0xf7,0x9c,0x80,0x23,0x01,0x00,0x00]
         negl	291(%r8,%rax,4), %ecx
# CHECK: {nf}	negl	291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x74,0x1c,0xf7,0x9c,0x80,0x23,0x01,0x00,0x00]
         {nf}	negl	291(%r8,%rax,4), %ecx
# CHECK: {evex}	negq	291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0xf7,0x9c,0x80,0x23,0x01,0x00,0x00]
         {evex}	negq	291(%r8,%rax,4)
# CHECK: {nf}	negq	291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0xf7,0x9c,0x80,0x23,0x01,0x00,0x00]
         {nf}	negq	291(%r8,%rax,4)
# CHECK: negq	291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x18,0xf7,0x9c,0x80,0x23,0x01,0x00,0x00]
         negq	291(%r8,%rax,4), %r9
# CHECK: {nf}	negq	291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x1c,0xf7,0x9c,0x80,0x23,0x01,0x00,0x00]
         {nf}	negq	291(%r8,%rax,4), %r9
