# RUN: llvm-mc -triple x86_64 -show-encoding %s | FileCheck %s
# RUN: not llvm-mc -triple i386 -show-encoding %s 2>&1 | FileCheck %s --check-prefix=ERROR

# ERROR-COUNT-104: error:
# ERROR-NOT: error:
# CHECK: {evex}	orb	$123, %bl
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0x80,0xcb,0x7b]
         {evex}	orb	$123, %bl
# CHECK: {nf}	orb	$123, %bl
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0x80,0xcb,0x7b]
         {nf}	orb	$123, %bl
# CHECK: orb	$123, %bl, %cl
# CHECK: encoding: [0x62,0xf4,0x74,0x18,0x80,0xcb,0x7b]
         orb	$123, %bl, %cl
# CHECK: {nf}	orb	$123, %bl, %cl
# CHECK: encoding: [0x62,0xf4,0x74,0x1c,0x80,0xcb,0x7b]
         {nf}	orb	$123, %bl, %cl
# CHECK: {evex}	orw	$123, %dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x08,0x83,0xca,0x7b]
         {evex}	orw	$123, %dx
# CHECK: {nf}	orw	$123, %dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x0c,0x83,0xca,0x7b]
         {nf}	orw	$123, %dx
# CHECK: orw	$123, %dx, %ax
# CHECK: encoding: [0x62,0xf4,0x7d,0x18,0x83,0xca,0x7b]
         orw	$123, %dx, %ax
# CHECK: {nf}	orw	$123, %dx, %ax
# CHECK: encoding: [0x62,0xf4,0x7d,0x1c,0x83,0xca,0x7b]
         {nf}	orw	$123, %dx, %ax
# CHECK: {evex}	orl	$123, %ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0x83,0xc9,0x7b]
         {evex}	orl	$123, %ecx
# CHECK: {nf}	orl	$123, %ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0x83,0xc9,0x7b]
         {nf}	orl	$123, %ecx
# CHECK: orl	$123, %ecx, %edx
# CHECK: encoding: [0x62,0xf4,0x6c,0x18,0x83,0xc9,0x7b]
         orl	$123, %ecx, %edx
# CHECK: {nf}	orl	$123, %ecx, %edx
# CHECK: encoding: [0x62,0xf4,0x6c,0x1c,0x83,0xc9,0x7b]
         {nf}	orl	$123, %ecx, %edx
# CHECK: {evex}	orq	$123, %r9
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0x83,0xc9,0x7b]
         {evex}	orq	$123, %r9
# CHECK: {nf}	orq	$123, %r9
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0x83,0xc9,0x7b]
         {nf}	orq	$123, %r9
# CHECK: orq	$123, %r9, %r15
# CHECK: encoding: [0x62,0xd4,0x84,0x18,0x83,0xc9,0x7b]
         orq	$123, %r9, %r15
# CHECK: {nf}	orq	$123, %r9, %r15
# CHECK: encoding: [0x62,0xd4,0x84,0x1c,0x83,0xc9,0x7b]
         {nf}	orq	$123, %r9, %r15
# CHECK: {evex}	orb	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0x80,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         {evex}	orb	$123, 291(%r8,%rax,4)
# CHECK: {nf}	orb	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0x80,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	orb	$123, 291(%r8,%rax,4)
# CHECK: orb	$123, 291(%r8,%rax,4), %bl
# CHECK: encoding: [0x62,0xd4,0x64,0x18,0x80,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         orb	$123, 291(%r8,%rax,4), %bl
# CHECK: {nf}	orb	$123, 291(%r8,%rax,4), %bl
# CHECK: encoding: [0x62,0xd4,0x64,0x1c,0x80,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	orb	$123, 291(%r8,%rax,4), %bl
# CHECK: {evex}	orw	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x08,0x83,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         {evex}	orw	$123, 291(%r8,%rax,4)
# CHECK: {nf}	orw	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x0c,0x83,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	orw	$123, 291(%r8,%rax,4)
# CHECK: orw	$123, 291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x6d,0x18,0x83,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         orw	$123, 291(%r8,%rax,4), %dx
# CHECK: {nf}	orw	$123, 291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x6d,0x1c,0x83,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	orw	$123, 291(%r8,%rax,4), %dx
# CHECK: {evex}	orl	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0x83,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         {evex}	orl	$123, 291(%r8,%rax,4)
# CHECK: {nf}	orl	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0x83,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	orl	$123, 291(%r8,%rax,4)
# CHECK: orl	$123, 291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x74,0x18,0x83,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         orl	$123, 291(%r8,%rax,4), %ecx
# CHECK: {nf}	orl	$123, 291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x74,0x1c,0x83,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	orl	$123, 291(%r8,%rax,4), %ecx
# CHECK: {evex}	orq	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0x83,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         {evex}	orq	$123, 291(%r8,%rax,4)
# CHECK: {nf}	orq	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0x83,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	orq	$123, 291(%r8,%rax,4)
# CHECK: orq	$123, 291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x18,0x83,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         orq	$123, 291(%r8,%rax,4), %r9
# CHECK: {nf}	orq	$123, 291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x1c,0x83,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	orq	$123, 291(%r8,%rax,4), %r9
# CHECK: {evex}	orw	$1234, %dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x08,0x81,0xca,0xd2,0x04]
         {evex}	orw	$1234, %dx
# CHECK: {nf}	orw	$1234, %dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x0c,0x81,0xca,0xd2,0x04]
         {nf}	orw	$1234, %dx
# CHECK: orw	$1234, %dx, %ax
# CHECK: encoding: [0x62,0xf4,0x7d,0x18,0x81,0xca,0xd2,0x04]
         orw	$1234, %dx, %ax
# CHECK: {nf}	orw	$1234, %dx, %ax
# CHECK: encoding: [0x62,0xf4,0x7d,0x1c,0x81,0xca,0xd2,0x04]
         {nf}	orw	$1234, %dx, %ax
# CHECK: {evex}	orw	$1234, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x08,0x81,0x8c,0x80,0x23,0x01,0x00,0x00,0xd2,0x04]
         {evex}	orw	$1234, 291(%r8,%rax,4)
# CHECK: {nf}	orw	$1234, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x0c,0x81,0x8c,0x80,0x23,0x01,0x00,0x00,0xd2,0x04]
         {nf}	orw	$1234, 291(%r8,%rax,4)
# CHECK: orw	$1234, 291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x6d,0x18,0x81,0x8c,0x80,0x23,0x01,0x00,0x00,0xd2,0x04]
         orw	$1234, 291(%r8,%rax,4), %dx
# CHECK: {nf}	orw	$1234, 291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x6d,0x1c,0x81,0x8c,0x80,0x23,0x01,0x00,0x00,0xd2,0x04]
         {nf}	orw	$1234, 291(%r8,%rax,4), %dx
# CHECK: {evex}	orl	$123456, %ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0x81,0xc9,0x40,0xe2,0x01,0x00]
         {evex}	orl	$123456, %ecx
# CHECK: {nf}	orl	$123456, %ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0x81,0xc9,0x40,0xe2,0x01,0x00]
         {nf}	orl	$123456, %ecx
# CHECK: orl	$123456, %ecx, %edx
# CHECK: encoding: [0x62,0xf4,0x6c,0x18,0x81,0xc9,0x40,0xe2,0x01,0x00]
         orl	$123456, %ecx, %edx
# CHECK: {nf}	orl	$123456, %ecx, %edx
# CHECK: encoding: [0x62,0xf4,0x6c,0x1c,0x81,0xc9,0x40,0xe2,0x01,0x00]
         {nf}	orl	$123456, %ecx, %edx
# CHECK: {evex}	orq	$123456, %r9
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0x81,0xc9,0x40,0xe2,0x01,0x00]
         {evex}	orq	$123456, %r9
# CHECK: {nf}	orq	$123456, %r9
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0x81,0xc9,0x40,0xe2,0x01,0x00]
         {nf}	orq	$123456, %r9
# CHECK: orq	$123456, %r9, %r15
# CHECK: encoding: [0x62,0xd4,0x84,0x18,0x81,0xc9,0x40,0xe2,0x01,0x00]
         orq	$123456, %r9, %r15
# CHECK: {nf}	orq	$123456, %r9, %r15
# CHECK: encoding: [0x62,0xd4,0x84,0x1c,0x81,0xc9,0x40,0xe2,0x01,0x00]
         {nf}	orq	$123456, %r9, %r15
# CHECK: {evex}	orl	$123456, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0x81,0x8c,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         {evex}	orl	$123456, 291(%r8,%rax,4)
# CHECK: {nf}	orl	$123456, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0x81,0x8c,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         {nf}	orl	$123456, 291(%r8,%rax,4)
# CHECK: orl	$123456, 291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x74,0x18,0x81,0x8c,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         orl	$123456, 291(%r8,%rax,4), %ecx
# CHECK: {nf}	orl	$123456, 291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x74,0x1c,0x81,0x8c,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         {nf}	orl	$123456, 291(%r8,%rax,4), %ecx
# CHECK: {evex}	orq	$123456, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0x81,0x8c,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         {evex}	orq	$123456, 291(%r8,%rax,4)
# CHECK: {nf}	orq	$123456, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0x81,0x8c,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         {nf}	orq	$123456, 291(%r8,%rax,4)
# CHECK: orq	$123456, 291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x18,0x81,0x8c,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         orq	$123456, 291(%r8,%rax,4), %r9
# CHECK: {nf}	orq	$123456, 291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x1c,0x81,0x8c,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         {nf}	orq	$123456, 291(%r8,%rax,4), %r9
# CHECK: {evex}	orb	%bl, %cl
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0x08,0xd9]
         {evex}	orb	%bl, %cl
# CHECK: {nf}	orb	%bl, %cl
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0x08,0xd9]
         {nf}	orb	%bl, %cl
# CHECK: orb	%bl, %cl, %r8b
# CHECK: encoding: [0x62,0xf4,0x3c,0x18,0x08,0xd9]
         orb	%bl, %cl, %r8b
# CHECK: {nf}	orb	%bl, %cl, %r8b
# CHECK: encoding: [0x62,0xf4,0x3c,0x1c,0x08,0xd9]
         {nf}	orb	%bl, %cl, %r8b
# CHECK: {evex}	orb	%bl, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0x08,0x9c,0x80,0x23,0x01,0x00,0x00]
         {evex}	orb	%bl, 291(%r8,%rax,4)
# CHECK: {nf}	orb	%bl, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0x08,0x9c,0x80,0x23,0x01,0x00,0x00]
         {nf}	orb	%bl, 291(%r8,%rax,4)
# CHECK: orb	%bl, 291(%r8,%rax,4), %cl
# CHECK: encoding: [0x62,0xd4,0x74,0x18,0x08,0x9c,0x80,0x23,0x01,0x00,0x00]
         orb	%bl, 291(%r8,%rax,4), %cl
# CHECK: {nf}	orb	%bl, 291(%r8,%rax,4), %cl
# CHECK: encoding: [0x62,0xd4,0x74,0x1c,0x08,0x9c,0x80,0x23,0x01,0x00,0x00]
         {nf}	orb	%bl, 291(%r8,%rax,4), %cl
# CHECK: {evex}	orw	%dx, %ax
# CHECK: encoding: [0x62,0xf4,0x7d,0x08,0x09,0xd0]
         {evex}	orw	%dx, %ax
# CHECK: {nf}	orw	%dx, %ax
# CHECK: encoding: [0x62,0xf4,0x7d,0x0c,0x09,0xd0]
         {nf}	orw	%dx, %ax
# CHECK: orw	%dx, %ax, %r9w
# CHECK: encoding: [0x62,0xf4,0x35,0x18,0x09,0xd0]
         orw	%dx, %ax, %r9w
# CHECK: {nf}	orw	%dx, %ax, %r9w
# CHECK: encoding: [0x62,0xf4,0x35,0x1c,0x09,0xd0]
         {nf}	orw	%dx, %ax, %r9w
# CHECK: {evex}	orw	%dx, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x08,0x09,0x94,0x80,0x23,0x01,0x00,0x00]
         {evex}	orw	%dx, 291(%r8,%rax,4)
# CHECK: {nf}	orw	%dx, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x0c,0x09,0x94,0x80,0x23,0x01,0x00,0x00]
         {nf}	orw	%dx, 291(%r8,%rax,4)
# CHECK: orw	%dx, 291(%r8,%rax,4), %ax
# CHECK: encoding: [0x62,0xd4,0x7d,0x18,0x09,0x94,0x80,0x23,0x01,0x00,0x00]
         orw	%dx, 291(%r8,%rax,4), %ax
# CHECK: {nf}	orw	%dx, 291(%r8,%rax,4), %ax
# CHECK: encoding: [0x62,0xd4,0x7d,0x1c,0x09,0x94,0x80,0x23,0x01,0x00,0x00]
         {nf}	orw	%dx, 291(%r8,%rax,4), %ax
# CHECK: {evex}	orl	%ecx, %edx
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0x09,0xca]
         {evex}	orl	%ecx, %edx
# CHECK: {nf}	orl	%ecx, %edx
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0x09,0xca]
         {nf}	orl	%ecx, %edx
# CHECK: orl	%ecx, %edx, %r10d
# CHECK: encoding: [0x62,0xf4,0x2c,0x18,0x09,0xca]
         orl	%ecx, %edx, %r10d
# CHECK: {nf}	orl	%ecx, %edx, %r10d
# CHECK: encoding: [0x62,0xf4,0x2c,0x1c,0x09,0xca]
         {nf}	orl	%ecx, %edx, %r10d
# CHECK: {evex}	orl	%ecx, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0x09,0x8c,0x80,0x23,0x01,0x00,0x00]
         {evex}	orl	%ecx, 291(%r8,%rax,4)
# CHECK: {nf}	orl	%ecx, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0x09,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	orl	%ecx, 291(%r8,%rax,4)
# CHECK: orl	%ecx, 291(%r8,%rax,4), %edx
# CHECK: encoding: [0x62,0xd4,0x6c,0x18,0x09,0x8c,0x80,0x23,0x01,0x00,0x00]
         orl	%ecx, 291(%r8,%rax,4), %edx
# CHECK: {nf}	orl	%ecx, 291(%r8,%rax,4), %edx
# CHECK: encoding: [0x62,0xd4,0x6c,0x1c,0x09,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	orl	%ecx, 291(%r8,%rax,4), %edx
# CHECK: {evex}	orq	%r9, %r15
# CHECK: encoding: [0x62,0x54,0xfc,0x08,0x09,0xcf]
         {evex}	orq	%r9, %r15
# CHECK: {nf}	orq	%r9, %r15
# CHECK: encoding: [0x62,0x54,0xfc,0x0c,0x09,0xcf]
         {nf}	orq	%r9, %r15
# CHECK: orq	%r9, %r15, %r11
# CHECK: encoding: [0x62,0x54,0xa4,0x18,0x09,0xcf]
         orq	%r9, %r15, %r11
# CHECK: {nf}	orq	%r9, %r15, %r11
# CHECK: encoding: [0x62,0x54,0xa4,0x1c,0x09,0xcf]
         {nf}	orq	%r9, %r15, %r11
# CHECK: {evex}	orq	%r9, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0x54,0xfc,0x08,0x09,0x8c,0x80,0x23,0x01,0x00,0x00]
         {evex}	orq	%r9, 291(%r8,%rax,4)
# CHECK: {nf}	orq	%r9, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0x54,0xfc,0x0c,0x09,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	orq	%r9, 291(%r8,%rax,4)
# CHECK: orq	%r9, 291(%r8,%rax,4), %r15
# CHECK: encoding: [0x62,0x54,0x84,0x18,0x09,0x8c,0x80,0x23,0x01,0x00,0x00]
         orq	%r9, 291(%r8,%rax,4), %r15
# CHECK: {nf}	orq	%r9, 291(%r8,%rax,4), %r15
# CHECK: encoding: [0x62,0x54,0x84,0x1c,0x09,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	orq	%r9, 291(%r8,%rax,4), %r15
# CHECK: {evex}	orb	291(%r8,%rax,4), %bl
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0x0a,0x9c,0x80,0x23,0x01,0x00,0x00]
         {evex}	orb	291(%r8,%rax,4), %bl
# CHECK: {nf}	orb	291(%r8,%rax,4), %bl
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0x0a,0x9c,0x80,0x23,0x01,0x00,0x00]
         {nf}	orb	291(%r8,%rax,4), %bl
# CHECK: orb	291(%r8,%rax,4), %bl, %cl
# CHECK: encoding: [0x62,0xd4,0x74,0x18,0x0a,0x9c,0x80,0x23,0x01,0x00,0x00]
         orb	291(%r8,%rax,4), %bl, %cl
# CHECK: {nf}	orb	291(%r8,%rax,4), %bl, %cl
# CHECK: encoding: [0x62,0xd4,0x74,0x1c,0x0a,0x9c,0x80,0x23,0x01,0x00,0x00]
         {nf}	orb	291(%r8,%rax,4), %bl, %cl
# CHECK: {evex}	orw	291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x7d,0x08,0x0b,0x94,0x80,0x23,0x01,0x00,0x00]
         {evex}	orw	291(%r8,%rax,4), %dx
# CHECK: {nf}	orw	291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x7d,0x0c,0x0b,0x94,0x80,0x23,0x01,0x00,0x00]
         {nf}	orw	291(%r8,%rax,4), %dx
# CHECK: orw	291(%r8,%rax,4), %dx, %ax
# CHECK: encoding: [0x62,0xd4,0x7d,0x18,0x0b,0x94,0x80,0x23,0x01,0x00,0x00]
         orw	291(%r8,%rax,4), %dx, %ax
# CHECK: {nf}	orw	291(%r8,%rax,4), %dx, %ax
# CHECK: encoding: [0x62,0xd4,0x7d,0x1c,0x0b,0x94,0x80,0x23,0x01,0x00,0x00]
         {nf}	orw	291(%r8,%rax,4), %dx, %ax
# CHECK: {evex}	orl	291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0x0b,0x8c,0x80,0x23,0x01,0x00,0x00]
         {evex}	orl	291(%r8,%rax,4), %ecx
# CHECK: {nf}	orl	291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0x0b,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	orl	291(%r8,%rax,4), %ecx
# CHECK: orl	291(%r8,%rax,4), %ecx, %edx
# CHECK: encoding: [0x62,0xd4,0x6c,0x18,0x0b,0x8c,0x80,0x23,0x01,0x00,0x00]
         orl	291(%r8,%rax,4), %ecx, %edx
# CHECK: {nf}	orl	291(%r8,%rax,4), %ecx, %edx
# CHECK: encoding: [0x62,0xd4,0x6c,0x1c,0x0b,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	orl	291(%r8,%rax,4), %ecx, %edx
# CHECK: {evex}	orq	291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0x54,0xfc,0x08,0x0b,0x8c,0x80,0x23,0x01,0x00,0x00]
         {evex}	orq	291(%r8,%rax,4), %r9
# CHECK: {nf}	orq	291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0x54,0xfc,0x0c,0x0b,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	orq	291(%r8,%rax,4), %r9
# CHECK: orq	291(%r8,%rax,4), %r9, %r15
# CHECK: encoding: [0x62,0x54,0x84,0x18,0x0b,0x8c,0x80,0x23,0x01,0x00,0x00]
         orq	291(%r8,%rax,4), %r9, %r15
# CHECK: {nf}	orq	291(%r8,%rax,4), %r9, %r15
# CHECK: encoding: [0x62,0x54,0x84,0x1c,0x0b,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	orq	291(%r8,%rax,4), %r9, %r15
