# RUN: llvm-mc -triple x86_64 -show-encoding -x86-asm-syntax=intel -output-asm-variant=1 %s | FileCheck %s

# CHECK: {evex}	or	bl, 123
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0x80,0xcb,0x7b]
         {evex}	or	bl, 123
# CHECK: {nf}	or	bl, 123
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0x80,0xcb,0x7b]
         {nf}	or	bl, 123
# CHECK: or	cl, bl, 123
# CHECK: encoding: [0x62,0xf4,0x74,0x18,0x80,0xcb,0x7b]
         or	cl, bl, 123
# CHECK: {nf}	or	cl, bl, 123
# CHECK: encoding: [0x62,0xf4,0x74,0x1c,0x80,0xcb,0x7b]
         {nf}	or	cl, bl, 123
# CHECK: {evex}	or	dx, 123
# CHECK: encoding: [0x62,0xf4,0x7d,0x08,0x83,0xca,0x7b]
         {evex}	or	dx, 123
# CHECK: {nf}	or	dx, 123
# CHECK: encoding: [0x62,0xf4,0x7d,0x0c,0x83,0xca,0x7b]
         {nf}	or	dx, 123
# CHECK: or	ax, dx, 123
# CHECK: encoding: [0x62,0xf4,0x7d,0x18,0x83,0xca,0x7b]
         or	ax, dx, 123
# CHECK: {nf}	or	ax, dx, 123
# CHECK: encoding: [0x62,0xf4,0x7d,0x1c,0x83,0xca,0x7b]
         {nf}	or	ax, dx, 123
# CHECK: {evex}	or	ecx, 123
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0x83,0xc9,0x7b]
         {evex}	or	ecx, 123
# CHECK: {nf}	or	ecx, 123
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0x83,0xc9,0x7b]
         {nf}	or	ecx, 123
# CHECK: or	edx, ecx, 123
# CHECK: encoding: [0x62,0xf4,0x6c,0x18,0x83,0xc9,0x7b]
         or	edx, ecx, 123
# CHECK: {nf}	or	edx, ecx, 123
# CHECK: encoding: [0x62,0xf4,0x6c,0x1c,0x83,0xc9,0x7b]
         {nf}	or	edx, ecx, 123
# CHECK: {evex}	or	r9, 123
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0x83,0xc9,0x7b]
         {evex}	or	r9, 123
# CHECK: {nf}	or	r9, 123
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0x83,0xc9,0x7b]
         {nf}	or	r9, 123
# CHECK: or	r15, r9, 123
# CHECK: encoding: [0x62,0xd4,0x84,0x18,0x83,0xc9,0x7b]
         or	r15, r9, 123
# CHECK: {nf}	or	r15, r9, 123
# CHECK: encoding: [0x62,0xd4,0x84,0x1c,0x83,0xc9,0x7b]
         {nf}	or	r15, r9, 123
# CHECK: {evex}	or	byte ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0x80,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         {evex}	or	byte ptr [r8 + 4*rax + 291], 123
# CHECK: {nf}	or	byte ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0x80,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	or	byte ptr [r8 + 4*rax + 291], 123
# CHECK: or	bl, byte ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0x64,0x18,0x80,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         or	bl, byte ptr [r8 + 4*rax + 291], 123
# CHECK: {nf}	or	bl, byte ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0x64,0x1c,0x80,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	or	bl, byte ptr [r8 + 4*rax + 291], 123
# CHECK: {evex}	or	word ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0x7d,0x08,0x83,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         {evex}	or	word ptr [r8 + 4*rax + 291], 123
# CHECK: {nf}	or	word ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0x7d,0x0c,0x83,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	or	word ptr [r8 + 4*rax + 291], 123
# CHECK: or	dx, word ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0x6d,0x18,0x83,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         or	dx, word ptr [r8 + 4*rax + 291], 123
# CHECK: {nf}	or	dx, word ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0x6d,0x1c,0x83,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	or	dx, word ptr [r8 + 4*rax + 291], 123
# CHECK: {evex}	or	dword ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0x83,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         {evex}	or	dword ptr [r8 + 4*rax + 291], 123
# CHECK: {nf}	or	dword ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0x83,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	or	dword ptr [r8 + 4*rax + 291], 123
# CHECK: or	ecx, dword ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0x74,0x18,0x83,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         or	ecx, dword ptr [r8 + 4*rax + 291], 123
# CHECK: {nf}	or	ecx, dword ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0x74,0x1c,0x83,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	or	ecx, dword ptr [r8 + 4*rax + 291], 123
# CHECK: {evex}	or	qword ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0x83,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         {evex}	or	qword ptr [r8 + 4*rax + 291], 123
# CHECK: {nf}	or	qword ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0x83,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	or	qword ptr [r8 + 4*rax + 291], 123
# CHECK: or	r9, qword ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0xb4,0x18,0x83,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         or	r9, qword ptr [r8 + 4*rax + 291], 123
# CHECK: {nf}	or	r9, qword ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0xb4,0x1c,0x83,0x8c,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	or	r9, qword ptr [r8 + 4*rax + 291], 123
# CHECK: {evex}	or	dx, 1234
# CHECK: encoding: [0x62,0xf4,0x7d,0x08,0x81,0xca,0xd2,0x04]
         {evex}	or	dx, 1234
# CHECK: {nf}	or	dx, 1234
# CHECK: encoding: [0x62,0xf4,0x7d,0x0c,0x81,0xca,0xd2,0x04]
         {nf}	or	dx, 1234
# CHECK: or	ax, dx, 1234
# CHECK: encoding: [0x62,0xf4,0x7d,0x18,0x81,0xca,0xd2,0x04]
         or	ax, dx, 1234
# CHECK: {nf}	or	ax, dx, 1234
# CHECK: encoding: [0x62,0xf4,0x7d,0x1c,0x81,0xca,0xd2,0x04]
         {nf}	or	ax, dx, 1234
# CHECK: {evex}	or	word ptr [r8 + 4*rax + 291], 1234
# CHECK: encoding: [0x62,0xd4,0x7d,0x08,0x81,0x8c,0x80,0x23,0x01,0x00,0x00,0xd2,0x04]
         {evex}	or	word ptr [r8 + 4*rax + 291], 1234
# CHECK: {nf}	or	word ptr [r8 + 4*rax + 291], 1234
# CHECK: encoding: [0x62,0xd4,0x7d,0x0c,0x81,0x8c,0x80,0x23,0x01,0x00,0x00,0xd2,0x04]
         {nf}	or	word ptr [r8 + 4*rax + 291], 1234
# CHECK: or	dx, word ptr [r8 + 4*rax + 291], 1234
# CHECK: encoding: [0x62,0xd4,0x6d,0x18,0x81,0x8c,0x80,0x23,0x01,0x00,0x00,0xd2,0x04]
         or	dx, word ptr [r8 + 4*rax + 291], 1234
# CHECK: {nf}	or	dx, word ptr [r8 + 4*rax + 291], 1234
# CHECK: encoding: [0x62,0xd4,0x6d,0x1c,0x81,0x8c,0x80,0x23,0x01,0x00,0x00,0xd2,0x04]
         {nf}	or	dx, word ptr [r8 + 4*rax + 291], 1234
# CHECK: {evex}	or	ecx, 123456
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0x81,0xc9,0x40,0xe2,0x01,0x00]
         {evex}	or	ecx, 123456
# CHECK: {nf}	or	ecx, 123456
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0x81,0xc9,0x40,0xe2,0x01,0x00]
         {nf}	or	ecx, 123456
# CHECK: or	edx, ecx, 123456
# CHECK: encoding: [0x62,0xf4,0x6c,0x18,0x81,0xc9,0x40,0xe2,0x01,0x00]
         or	edx, ecx, 123456
# CHECK: {nf}	or	edx, ecx, 123456
# CHECK: encoding: [0x62,0xf4,0x6c,0x1c,0x81,0xc9,0x40,0xe2,0x01,0x00]
         {nf}	or	edx, ecx, 123456
# CHECK: {evex}	or	r9, 123456
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0x81,0xc9,0x40,0xe2,0x01,0x00]
         {evex}	or	r9, 123456
# CHECK: {nf}	or	r9, 123456
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0x81,0xc9,0x40,0xe2,0x01,0x00]
         {nf}	or	r9, 123456
# CHECK: or	r15, r9, 123456
# CHECK: encoding: [0x62,0xd4,0x84,0x18,0x81,0xc9,0x40,0xe2,0x01,0x00]
         or	r15, r9, 123456
# CHECK: {nf}	or	r15, r9, 123456
# CHECK: encoding: [0x62,0xd4,0x84,0x1c,0x81,0xc9,0x40,0xe2,0x01,0x00]
         {nf}	or	r15, r9, 123456
# CHECK: {evex}	or	dword ptr [r8 + 4*rax + 291], 123456
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0x81,0x8c,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         {evex}	or	dword ptr [r8 + 4*rax + 291], 123456
# CHECK: {nf}	or	dword ptr [r8 + 4*rax + 291], 123456
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0x81,0x8c,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         {nf}	or	dword ptr [r8 + 4*rax + 291], 123456
# CHECK: or	ecx, dword ptr [r8 + 4*rax + 291], 123456
# CHECK: encoding: [0x62,0xd4,0x74,0x18,0x81,0x8c,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         or	ecx, dword ptr [r8 + 4*rax + 291], 123456
# CHECK: {nf}	or	ecx, dword ptr [r8 + 4*rax + 291], 123456
# CHECK: encoding: [0x62,0xd4,0x74,0x1c,0x81,0x8c,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         {nf}	or	ecx, dword ptr [r8 + 4*rax + 291], 123456
# CHECK: {evex}	or	qword ptr [r8 + 4*rax + 291], 123456
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0x81,0x8c,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         {evex}	or	qword ptr [r8 + 4*rax + 291], 123456
# CHECK: {nf}	or	qword ptr [r8 + 4*rax + 291], 123456
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0x81,0x8c,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         {nf}	or	qword ptr [r8 + 4*rax + 291], 123456
# CHECK: or	r9, qword ptr [r8 + 4*rax + 291], 123456
# CHECK: encoding: [0x62,0xd4,0xb4,0x18,0x81,0x8c,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         or	r9, qword ptr [r8 + 4*rax + 291], 123456
# CHECK: {nf}	or	r9, qword ptr [r8 + 4*rax + 291], 123456
# CHECK: encoding: [0x62,0xd4,0xb4,0x1c,0x81,0x8c,0x80,0x23,0x01,0x00,0x00,0x40,0xe2,0x01,0x00]
         {nf}	or	r9, qword ptr [r8 + 4*rax + 291], 123456
# CHECK: {evex}	or	cl, bl
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0x08,0xd9]
         {evex}	or	cl, bl
# CHECK: {nf}	or	cl, bl
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0x08,0xd9]
         {nf}	or	cl, bl
# CHECK: or	r8b, cl, bl
# CHECK: encoding: [0x62,0xf4,0x3c,0x18,0x08,0xd9]
         or	r8b, cl, bl
# CHECK: {nf}	or	r8b, cl, bl
# CHECK: encoding: [0x62,0xf4,0x3c,0x1c,0x08,0xd9]
         {nf}	or	r8b, cl, bl
# CHECK: {evex}	or	byte ptr [r8 + 4*rax + 291], bl
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0x08,0x9c,0x80,0x23,0x01,0x00,0x00]
         {evex}	or	byte ptr [r8 + 4*rax + 291], bl
# CHECK: {nf}	or	byte ptr [r8 + 4*rax + 291], bl
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0x08,0x9c,0x80,0x23,0x01,0x00,0x00]
         {nf}	or	byte ptr [r8 + 4*rax + 291], bl
# CHECK: or	cl, byte ptr [r8 + 4*rax + 291], bl
# CHECK: encoding: [0x62,0xd4,0x74,0x18,0x08,0x9c,0x80,0x23,0x01,0x00,0x00]
         or	cl, byte ptr [r8 + 4*rax + 291], bl
# CHECK: {nf}	or	cl, byte ptr [r8 + 4*rax + 291], bl
# CHECK: encoding: [0x62,0xd4,0x74,0x1c,0x08,0x9c,0x80,0x23,0x01,0x00,0x00]
         {nf}	or	cl, byte ptr [r8 + 4*rax + 291], bl
# CHECK: {evex}	or	ax, dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x08,0x09,0xd0]
         {evex}	or	ax, dx
# CHECK: {nf}	or	ax, dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x0c,0x09,0xd0]
         {nf}	or	ax, dx
# CHECK: or	r9w, ax, dx
# CHECK: encoding: [0x62,0xf4,0x35,0x18,0x09,0xd0]
         or	r9w, ax, dx
# CHECK: {nf}	or	r9w, ax, dx
# CHECK: encoding: [0x62,0xf4,0x35,0x1c,0x09,0xd0]
         {nf}	or	r9w, ax, dx
# CHECK: {evex}	or	word ptr [r8 + 4*rax + 291], dx
# CHECK: encoding: [0x62,0xd4,0x7d,0x08,0x09,0x94,0x80,0x23,0x01,0x00,0x00]
         {evex}	or	word ptr [r8 + 4*rax + 291], dx
# CHECK: {nf}	or	word ptr [r8 + 4*rax + 291], dx
# CHECK: encoding: [0x62,0xd4,0x7d,0x0c,0x09,0x94,0x80,0x23,0x01,0x00,0x00]
         {nf}	or	word ptr [r8 + 4*rax + 291], dx
# CHECK: or	ax, word ptr [r8 + 4*rax + 291], dx
# CHECK: encoding: [0x62,0xd4,0x7d,0x18,0x09,0x94,0x80,0x23,0x01,0x00,0x00]
         or	ax, word ptr [r8 + 4*rax + 291], dx
# CHECK: {nf}	or	ax, word ptr [r8 + 4*rax + 291], dx
# CHECK: encoding: [0x62,0xd4,0x7d,0x1c,0x09,0x94,0x80,0x23,0x01,0x00,0x00]
         {nf}	or	ax, word ptr [r8 + 4*rax + 291], dx
# CHECK: {evex}	or	edx, ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0x09,0xca]
         {evex}	or	edx, ecx
# CHECK: {nf}	or	edx, ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0x09,0xca]
         {nf}	or	edx, ecx
# CHECK: or	r10d, edx, ecx
# CHECK: encoding: [0x62,0xf4,0x2c,0x18,0x09,0xca]
         or	r10d, edx, ecx
# CHECK: {nf}	or	r10d, edx, ecx
# CHECK: encoding: [0x62,0xf4,0x2c,0x1c,0x09,0xca]
         {nf}	or	r10d, edx, ecx
# CHECK: {evex}	or	dword ptr [r8 + 4*rax + 291], ecx
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0x09,0x8c,0x80,0x23,0x01,0x00,0x00]
         {evex}	or	dword ptr [r8 + 4*rax + 291], ecx
# CHECK: {nf}	or	dword ptr [r8 + 4*rax + 291], ecx
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0x09,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	or	dword ptr [r8 + 4*rax + 291], ecx
# CHECK: or	edx, dword ptr [r8 + 4*rax + 291], ecx
# CHECK: encoding: [0x62,0xd4,0x6c,0x18,0x09,0x8c,0x80,0x23,0x01,0x00,0x00]
         or	edx, dword ptr [r8 + 4*rax + 291], ecx
# CHECK: {nf}	or	edx, dword ptr [r8 + 4*rax + 291], ecx
# CHECK: encoding: [0x62,0xd4,0x6c,0x1c,0x09,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	or	edx, dword ptr [r8 + 4*rax + 291], ecx
# CHECK: {evex}	or	r15, r9
# CHECK: encoding: [0x62,0x54,0xfc,0x08,0x09,0xcf]
         {evex}	or	r15, r9
# CHECK: {nf}	or	r15, r9
# CHECK: encoding: [0x62,0x54,0xfc,0x0c,0x09,0xcf]
         {nf}	or	r15, r9
# CHECK: or	r11, r15, r9
# CHECK: encoding: [0x62,0x54,0xa4,0x18,0x09,0xcf]
         or	r11, r15, r9
# CHECK: {nf}	or	r11, r15, r9
# CHECK: encoding: [0x62,0x54,0xa4,0x1c,0x09,0xcf]
         {nf}	or	r11, r15, r9
# CHECK: {evex}	or	qword ptr [r8 + 4*rax + 291], r9
# CHECK: encoding: [0x62,0x54,0xfc,0x08,0x09,0x8c,0x80,0x23,0x01,0x00,0x00]
         {evex}	or	qword ptr [r8 + 4*rax + 291], r9
# CHECK: {nf}	or	qword ptr [r8 + 4*rax + 291], r9
# CHECK: encoding: [0x62,0x54,0xfc,0x0c,0x09,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	or	qword ptr [r8 + 4*rax + 291], r9
# CHECK: or	r15, qword ptr [r8 + 4*rax + 291], r9
# CHECK: encoding: [0x62,0x54,0x84,0x18,0x09,0x8c,0x80,0x23,0x01,0x00,0x00]
         or	r15, qword ptr [r8 + 4*rax + 291], r9
# CHECK: {nf}	or	r15, qword ptr [r8 + 4*rax + 291], r9
# CHECK: encoding: [0x62,0x54,0x84,0x1c,0x09,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	or	r15, qword ptr [r8 + 4*rax + 291], r9
# CHECK: {evex}	or	bl, byte ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0x0a,0x9c,0x80,0x23,0x01,0x00,0x00]
         {evex}	or	bl, byte ptr [r8 + 4*rax + 291]
# CHECK: {nf}	or	bl, byte ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0x0a,0x9c,0x80,0x23,0x01,0x00,0x00]
         {nf}	or	bl, byte ptr [r8 + 4*rax + 291]
# CHECK: or	cl, bl, byte ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x74,0x18,0x0a,0x9c,0x80,0x23,0x01,0x00,0x00]
         or	cl, bl, byte ptr [r8 + 4*rax + 291]
# CHECK: {nf}	or	cl, bl, byte ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x74,0x1c,0x0a,0x9c,0x80,0x23,0x01,0x00,0x00]
         {nf}	or	cl, bl, byte ptr [r8 + 4*rax + 291]
# CHECK: {evex}	or	dx, word ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x7d,0x08,0x0b,0x94,0x80,0x23,0x01,0x00,0x00]
         {evex}	or	dx, word ptr [r8 + 4*rax + 291]
# CHECK: {nf}	or	dx, word ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x7d,0x0c,0x0b,0x94,0x80,0x23,0x01,0x00,0x00]
         {nf}	or	dx, word ptr [r8 + 4*rax + 291]
# CHECK: or	ax, dx, word ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x7d,0x18,0x0b,0x94,0x80,0x23,0x01,0x00,0x00]
         or	ax, dx, word ptr [r8 + 4*rax + 291]
# CHECK: {nf}	or	ax, dx, word ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x7d,0x1c,0x0b,0x94,0x80,0x23,0x01,0x00,0x00]
         {nf}	or	ax, dx, word ptr [r8 + 4*rax + 291]
# CHECK: {evex}	or	ecx, dword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0x0b,0x8c,0x80,0x23,0x01,0x00,0x00]
         {evex}	or	ecx, dword ptr [r8 + 4*rax + 291]
# CHECK: {nf}	or	ecx, dword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0x0b,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	or	ecx, dword ptr [r8 + 4*rax + 291]
# CHECK: or	edx, ecx, dword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x6c,0x18,0x0b,0x8c,0x80,0x23,0x01,0x00,0x00]
         or	edx, ecx, dword ptr [r8 + 4*rax + 291]
# CHECK: {nf}	or	edx, ecx, dword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x6c,0x1c,0x0b,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	or	edx, ecx, dword ptr [r8 + 4*rax + 291]
# CHECK: {evex}	or	r9, qword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0x54,0xfc,0x08,0x0b,0x8c,0x80,0x23,0x01,0x00,0x00]
         {evex}	or	r9, qword ptr [r8 + 4*rax + 291]
# CHECK: {nf}	or	r9, qword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0x54,0xfc,0x0c,0x0b,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	or	r9, qword ptr [r8 + 4*rax + 291]
# CHECK: or	r15, r9, qword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0x54,0x84,0x18,0x0b,0x8c,0x80,0x23,0x01,0x00,0x00]
         or	r15, r9, qword ptr [r8 + 4*rax + 291]
# CHECK: {nf}	or	r15, r9, qword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0x54,0x84,0x1c,0x0b,0x8c,0x80,0x23,0x01,0x00,0x00]
         {nf}	or	r15, r9, qword ptr [r8 + 4*rax + 291]
