# RUN: llvm-mc -triple x86_64 -show-encoding %s | FileCheck %s
# RUN: not llvm-mc -triple i386 -show-encoding %s 2>&1 | FileCheck %s --check-prefix=ERROR

# ERROR-COUNT-94: error:
# ERROR-NOT: error:
# CHECK: {evex}	shrb	$123, %bl
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0xc0,0xeb,0x7b]
         {evex}	shrb	$123, %bl
# CHECK: {nf}	shrb	$123, %bl
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0xc0,0xeb,0x7b]
         {nf}	shrb	$123, %bl
# CHECK: shrb	$123, %bl, %bl
# CHECK: encoding: [0x62,0xf4,0x64,0x18,0xc0,0xeb,0x7b]
         shrb	$123, %bl, %bl
# CHECK: {nf}	shrb	$123, %bl, %bl
# CHECK: encoding: [0x62,0xf4,0x64,0x1c,0xc0,0xeb,0x7b]
         {nf}	shrb	$123, %bl, %bl
# CHECK: {evex}	shrw	$123, %dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x08,0xc1,0xea,0x7b]
         {evex}	shrw	$123, %dx
# CHECK: {nf}	shrw	$123, %dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x0c,0xc1,0xea,0x7b]
         {nf}	shrw	$123, %dx
# CHECK: shrw	$123, %dx, %dx
# CHECK: encoding: [0x62,0xf4,0x6d,0x18,0xc1,0xea,0x7b]
         shrw	$123, %dx, %dx
# CHECK: {nf}	shrw	$123, %dx, %dx
# CHECK: encoding: [0x62,0xf4,0x6d,0x1c,0xc1,0xea,0x7b]
         {nf}	shrw	$123, %dx, %dx
# CHECK: {evex}	shrl	$123, %ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0xc1,0xe9,0x7b]
         {evex}	shrl	$123, %ecx
# CHECK: {nf}	shrl	$123, %ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0xc1,0xe9,0x7b]
         {nf}	shrl	$123, %ecx
# CHECK: shrl	$123, %ecx, %ecx
# CHECK: encoding: [0x62,0xf4,0x74,0x18,0xc1,0xe9,0x7b]
         shrl	$123, %ecx, %ecx
# CHECK: {nf}	shrl	$123, %ecx, %ecx
# CHECK: encoding: [0x62,0xf4,0x74,0x1c,0xc1,0xe9,0x7b]
         {nf}	shrl	$123, %ecx, %ecx
# CHECK: {evex}	shrq	$123, %r9
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0xc1,0xe9,0x7b]
         {evex}	shrq	$123, %r9
# CHECK: {nf}	shrq	$123, %r9
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0xc1,0xe9,0x7b]
         {nf}	shrq	$123, %r9
# CHECK: shrq	$123, %r9, %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x18,0xc1,0xe9,0x7b]
         shrq	$123, %r9, %r9
# CHECK: {nf}	shrq	$123, %r9, %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x1c,0xc1,0xe9,0x7b]
         {nf}	shrq	$123, %r9, %r9
# CHECK: {evex}	shrb	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0xc0,0xac,0x80,0x23,0x01,0x00,0x00,0x7b]
         {evex}	shrb	$123, 291(%r8,%rax,4)
# CHECK: {nf}	shrb	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0xc0,0xac,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	shrb	$123, 291(%r8,%rax,4)
# CHECK: shrb	$123, 291(%r8,%rax,4), %bl
# CHECK: encoding: [0x62,0xd4,0x64,0x18,0xc0,0xac,0x80,0x23,0x01,0x00,0x00,0x7b]
         shrb	$123, 291(%r8,%rax,4), %bl
# CHECK: {nf}	shrb	$123, 291(%r8,%rax,4), %bl
# CHECK: encoding: [0x62,0xd4,0x64,0x1c,0xc0,0xac,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	shrb	$123, 291(%r8,%rax,4), %bl
# CHECK: {evex}	shrw	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x08,0xc1,0xac,0x80,0x23,0x01,0x00,0x00,0x7b]
         {evex}	shrw	$123, 291(%r8,%rax,4)
# CHECK: {nf}	shrw	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x0c,0xc1,0xac,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	shrw	$123, 291(%r8,%rax,4)
# CHECK: shrw	$123, 291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x6d,0x18,0xc1,0xac,0x80,0x23,0x01,0x00,0x00,0x7b]
         shrw	$123, 291(%r8,%rax,4), %dx
# CHECK: {nf}	shrw	$123, 291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x6d,0x1c,0xc1,0xac,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	shrw	$123, 291(%r8,%rax,4), %dx
# CHECK: {evex}	shrl	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0xc1,0xac,0x80,0x23,0x01,0x00,0x00,0x7b]
         {evex}	shrl	$123, 291(%r8,%rax,4)
# CHECK: {nf}	shrl	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0xc1,0xac,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	shrl	$123, 291(%r8,%rax,4)
# CHECK: shrl	$123, 291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x74,0x18,0xc1,0xac,0x80,0x23,0x01,0x00,0x00,0x7b]
         shrl	$123, 291(%r8,%rax,4), %ecx
# CHECK: {nf}	shrl	$123, 291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x74,0x1c,0xc1,0xac,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	shrl	$123, 291(%r8,%rax,4), %ecx
# CHECK: {evex}	shrq	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0xc1,0xac,0x80,0x23,0x01,0x00,0x00,0x7b]
         {evex}	shrq	$123, 291(%r8,%rax,4)
# CHECK: {nf}	shrq	$123, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0xc1,0xac,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	shrq	$123, 291(%r8,%rax,4)
# CHECK: shrq	$123, 291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x18,0xc1,0xac,0x80,0x23,0x01,0x00,0x00,0x7b]
         shrq	$123, 291(%r8,%rax,4), %r9
# CHECK: {nf}	shrq	$123, 291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x1c,0xc1,0xac,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	shrq	$123, 291(%r8,%rax,4), %r9
# CHECK: {evex}	shrb	%bl
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0xd0,0xeb]
         {evex}	shrb	%bl
# CHECK: {nf}	shrb	%bl
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0xd0,0xeb]
         {nf}	shrb	%bl
# CHECK: {evex}	shrb	%cl, %bl
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0xd2,0xeb]
         {evex}	shrb	%cl, %bl
# CHECK: {nf}	shrb	%cl, %bl
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0xd2,0xeb]
         {nf}	shrb	%cl, %bl
# CHECK: shrb	%cl, %bl, %bl
# CHECK: encoding: [0x62,0xf4,0x64,0x18,0xd2,0xeb]
         shrb	%cl, %bl, %bl
# CHECK: {nf}	shrb	%cl, %bl, %bl
# CHECK: encoding: [0x62,0xf4,0x64,0x1c,0xd2,0xeb]
         {nf}	shrb	%cl, %bl, %bl
# CHECK: {evex}	shrw	%cl, %dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x08,0xd3,0xea]
         {evex}	shrw	%cl, %dx
# CHECK: {nf}	shrw	%cl, %dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x0c,0xd3,0xea]
         {nf}	shrw	%cl, %dx
# CHECK: shrw	%cl, %dx, %dx
# CHECK: encoding: [0x62,0xf4,0x6d,0x18,0xd3,0xea]
         shrw	%cl, %dx, %dx
# CHECK: {nf}	shrw	%cl, %dx, %dx
# CHECK: encoding: [0x62,0xf4,0x6d,0x1c,0xd3,0xea]
         {nf}	shrw	%cl, %dx, %dx
# CHECK: {evex}	shrl	%cl, %ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0xd3,0xe9]
         {evex}	shrl	%cl, %ecx
# CHECK: {nf}	shrl	%cl, %ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0xd3,0xe9]
         {nf}	shrl	%cl, %ecx
# CHECK: shrl	%cl, %ecx, %ecx
# CHECK: encoding: [0x62,0xf4,0x74,0x18,0xd3,0xe9]
         shrl	%cl, %ecx, %ecx
# CHECK: {nf}	shrl	%cl, %ecx, %ecx
# CHECK: encoding: [0x62,0xf4,0x74,0x1c,0xd3,0xe9]
         {nf}	shrl	%cl, %ecx, %ecx
# CHECK: {evex}	shrq	%cl, %r9
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0xd3,0xe9]
         {evex}	shrq	%cl, %r9
# CHECK: {nf}	shrq	%cl, %r9
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0xd3,0xe9]
         {nf}	shrq	%cl, %r9
# CHECK: shrq	%cl, %r9, %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x18,0xd3,0xe9]
         shrq	%cl, %r9, %r9
# CHECK: {nf}	shrq	%cl, %r9, %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x1c,0xd3,0xe9]
         {nf}	shrq	%cl, %r9, %r9
# CHECK: {evex}	shrb	%cl, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0xd2,0xac,0x80,0x23,0x01,0x00,0x00]
         {evex}	shrb	%cl, 291(%r8,%rax,4)
# CHECK: {nf}	shrb	%cl, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0xd2,0xac,0x80,0x23,0x01,0x00,0x00]
         {nf}	shrb	%cl, 291(%r8,%rax,4)
# CHECK: shrb	%cl, 291(%r8,%rax,4), %bl
# CHECK: encoding: [0x62,0xd4,0x64,0x18,0xd2,0xac,0x80,0x23,0x01,0x00,0x00]
         shrb	%cl, 291(%r8,%rax,4), %bl
# CHECK: {nf}	shrb	%cl, 291(%r8,%rax,4), %bl
# CHECK: encoding: [0x62,0xd4,0x64,0x1c,0xd2,0xac,0x80,0x23,0x01,0x00,0x00]
         {nf}	shrb	%cl, 291(%r8,%rax,4), %bl
# CHECK: {evex}	shrw	%cl, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x08,0xd3,0xac,0x80,0x23,0x01,0x00,0x00]
         {evex}	shrw	%cl, 291(%r8,%rax,4)
# CHECK: {nf}	shrw	%cl, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x0c,0xd3,0xac,0x80,0x23,0x01,0x00,0x00]
         {nf}	shrw	%cl, 291(%r8,%rax,4)
# CHECK: shrw	%cl, 291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x6d,0x18,0xd3,0xac,0x80,0x23,0x01,0x00,0x00]
         shrw	%cl, 291(%r8,%rax,4), %dx
# CHECK: {nf}	shrw	%cl, 291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x6d,0x1c,0xd3,0xac,0x80,0x23,0x01,0x00,0x00]
         {nf}	shrw	%cl, 291(%r8,%rax,4), %dx
# CHECK: {evex}	shrl	%cl, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0xd3,0xac,0x80,0x23,0x01,0x00,0x00]
         {evex}	shrl	%cl, 291(%r8,%rax,4)
# CHECK: {nf}	shrl	%cl, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0xd3,0xac,0x80,0x23,0x01,0x00,0x00]
         {nf}	shrl	%cl, 291(%r8,%rax,4)
# CHECK: shrl	%cl, 291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x74,0x18,0xd3,0xac,0x80,0x23,0x01,0x00,0x00]
         shrl	%cl, 291(%r8,%rax,4), %ecx
# CHECK: {nf}	shrl	%cl, 291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x74,0x1c,0xd3,0xac,0x80,0x23,0x01,0x00,0x00]
         {nf}	shrl	%cl, 291(%r8,%rax,4), %ecx
# CHECK: {evex}	shrq	%cl, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0xd3,0xac,0x80,0x23,0x01,0x00,0x00]
         {evex}	shrq	%cl, 291(%r8,%rax,4)
# CHECK: {nf}	shrq	%cl, 291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0xd3,0xac,0x80,0x23,0x01,0x00,0x00]
         {nf}	shrq	%cl, 291(%r8,%rax,4)
# CHECK: shrq	%cl, 291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x18,0xd3,0xac,0x80,0x23,0x01,0x00,0x00]
         shrq	%cl, 291(%r8,%rax,4), %r9
# CHECK: {nf}	shrq	%cl, 291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x1c,0xd3,0xac,0x80,0x23,0x01,0x00,0x00]
         {nf}	shrq	%cl, 291(%r8,%rax,4), %r9
# CHECK: {evex}	shrw	%dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x08,0xd1,0xea]
         {evex}	shrw	%dx
# CHECK: {nf}	shrw	%dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x0c,0xd1,0xea]
         {nf}	shrw	%dx
# CHECK: shrw	%dx, %dx
# CHECK: encoding: [0x62,0xf4,0x6d,0x18,0xd1,0xea]
         shrw	%dx, %dx
# CHECK: {nf}	shrw	%dx, %dx
# CHECK: encoding: [0x62,0xf4,0x6d,0x1c,0xd1,0xea]
         {nf}	shrw	%dx, %dx
# CHECK: {evex}	shrl	%ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0xd1,0xe9]
         {evex}	shrl	%ecx
# CHECK: {nf}	shrl	%ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0xd1,0xe9]
         {nf}	shrl	%ecx
# CHECK: shrl	%ecx, %ecx
# CHECK: encoding: [0x62,0xf4,0x74,0x18,0xd1,0xe9]
         shrl	%ecx, %ecx
# CHECK: {nf}	shrl	%ecx, %ecx
# CHECK: encoding: [0x62,0xf4,0x74,0x1c,0xd1,0xe9]
         {nf}	shrl	%ecx, %ecx
# CHECK: {evex}	shrq	%r9
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0xd1,0xe9]
         {evex}	shrq	%r9
# CHECK: {nf}	shrq	%r9
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0xd1,0xe9]
         {nf}	shrq	%r9
# CHECK: shrq	%r9, %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x18,0xd1,0xe9]
         shrq	%r9, %r9
# CHECK: {nf}	shrq	%r9, %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x1c,0xd1,0xe9]
         {nf}	shrq	%r9, %r9
# CHECK: {evex}	shrb	291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0xd0,0xac,0x80,0x23,0x01,0x00,0x00]
         {evex}	shrb	291(%r8,%rax,4)
# CHECK: {nf}	shrb	291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0xd0,0xac,0x80,0x23,0x01,0x00,0x00]
         {nf}	shrb	291(%r8,%rax,4)
# CHECK: shrb	291(%r8,%rax,4), %bl
# CHECK: encoding: [0x62,0xd4,0x64,0x18,0xd0,0xac,0x80,0x23,0x01,0x00,0x00]
         shrb	291(%r8,%rax,4), %bl
# CHECK: {nf}	shrb	291(%r8,%rax,4), %bl
# CHECK: encoding: [0x62,0xd4,0x64,0x1c,0xd0,0xac,0x80,0x23,0x01,0x00,0x00]
         {nf}	shrb	291(%r8,%rax,4), %bl
# CHECK: {evex}	shrw	291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x08,0xd1,0xac,0x80,0x23,0x01,0x00,0x00]
         {evex}	shrw	291(%r8,%rax,4)
# CHECK: {nf}	shrw	291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7d,0x0c,0xd1,0xac,0x80,0x23,0x01,0x00,0x00]
         {nf}	shrw	291(%r8,%rax,4)
# CHECK: shrw	291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x6d,0x18,0xd1,0xac,0x80,0x23,0x01,0x00,0x00]
         shrw	291(%r8,%rax,4), %dx
# CHECK: {nf}	shrw	291(%r8,%rax,4), %dx
# CHECK: encoding: [0x62,0xd4,0x6d,0x1c,0xd1,0xac,0x80,0x23,0x01,0x00,0x00]
         {nf}	shrw	291(%r8,%rax,4), %dx
# CHECK: {evex}	shrl	291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0xd1,0xac,0x80,0x23,0x01,0x00,0x00]
         {evex}	shrl	291(%r8,%rax,4)
# CHECK: {nf}	shrl	291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0xd1,0xac,0x80,0x23,0x01,0x00,0x00]
         {nf}	shrl	291(%r8,%rax,4)
# CHECK: shrl	291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x74,0x18,0xd1,0xac,0x80,0x23,0x01,0x00,0x00]
         shrl	291(%r8,%rax,4), %ecx
# CHECK: {nf}	shrl	291(%r8,%rax,4), %ecx
# CHECK: encoding: [0x62,0xd4,0x74,0x1c,0xd1,0xac,0x80,0x23,0x01,0x00,0x00]
         {nf}	shrl	291(%r8,%rax,4), %ecx
# CHECK: {evex}	shrq	291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0xd1,0xac,0x80,0x23,0x01,0x00,0x00]
         {evex}	shrq	291(%r8,%rax,4)
# CHECK: {nf}	shrq	291(%r8,%rax,4)
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0xd1,0xac,0x80,0x23,0x01,0x00,0x00]
         {nf}	shrq	291(%r8,%rax,4)
# CHECK: shrq	291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x18,0xd1,0xac,0x80,0x23,0x01,0x00,0x00]
         shrq	291(%r8,%rax,4), %r9
# CHECK: {nf}	shrq	291(%r8,%rax,4), %r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x1c,0xd1,0xac,0x80,0x23,0x01,0x00,0x00]
         {nf}	shrq	291(%r8,%rax,4), %r9
