# RUN: llvm-mc -triple x86_64 -show-encoding -x86-asm-syntax=intel -output-asm-variant=1 %s | FileCheck %s

# CHECK: {evex}	shr	bl, 123
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0xc0,0xeb,0x7b]
         {evex}	shr	bl, 123
# CHECK: {nf}	shr	bl, 123
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0xc0,0xeb,0x7b]
         {nf}	shr	bl, 123
# CHECK: shr	bl, bl, 123
# CHECK: encoding: [0x62,0xf4,0x64,0x18,0xc0,0xeb,0x7b]
         shr	bl, bl, 123
# CHECK: {nf}	shr	bl, bl, 123
# CHECK: encoding: [0x62,0xf4,0x64,0x1c,0xc0,0xeb,0x7b]
         {nf}	shr	bl, bl, 123
# CHECK: {evex}	shr	dx, 123
# CHECK: encoding: [0x62,0xf4,0x7d,0x08,0xc1,0xea,0x7b]
         {evex}	shr	dx, 123
# CHECK: {nf}	shr	dx, 123
# CHECK: encoding: [0x62,0xf4,0x7d,0x0c,0xc1,0xea,0x7b]
         {nf}	shr	dx, 123
# CHECK: shr	dx, dx, 123
# CHECK: encoding: [0x62,0xf4,0x6d,0x18,0xc1,0xea,0x7b]
         shr	dx, dx, 123
# CHECK: {nf}	shr	dx, dx, 123
# CHECK: encoding: [0x62,0xf4,0x6d,0x1c,0xc1,0xea,0x7b]
         {nf}	shr	dx, dx, 123
# CHECK: {evex}	shr	ecx, 123
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0xc1,0xe9,0x7b]
         {evex}	shr	ecx, 123
# CHECK: {nf}	shr	ecx, 123
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0xc1,0xe9,0x7b]
         {nf}	shr	ecx, 123
# CHECK: shr	ecx, ecx, 123
# CHECK: encoding: [0x62,0xf4,0x74,0x18,0xc1,0xe9,0x7b]
         shr	ecx, ecx, 123
# CHECK: {nf}	shr	ecx, ecx, 123
# CHECK: encoding: [0x62,0xf4,0x74,0x1c,0xc1,0xe9,0x7b]
         {nf}	shr	ecx, ecx, 123
# CHECK: {evex}	shr	r9, 123
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0xc1,0xe9,0x7b]
         {evex}	shr	r9, 123
# CHECK: {nf}	shr	r9, 123
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0xc1,0xe9,0x7b]
         {nf}	shr	r9, 123
# CHECK: shr	r9, r9, 123
# CHECK: encoding: [0x62,0xd4,0xb4,0x18,0xc1,0xe9,0x7b]
         shr	r9, r9, 123
# CHECK: {nf}	shr	r9, r9, 123
# CHECK: encoding: [0x62,0xd4,0xb4,0x1c,0xc1,0xe9,0x7b]
         {nf}	shr	r9, r9, 123
# CHECK: {evex}	shr	byte ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0xc0,0xac,0x80,0x23,0x01,0x00,0x00,0x7b]
         {evex}	shr	byte ptr [r8 + 4*rax + 291], 123
# CHECK: {nf}	shr	byte ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0xc0,0xac,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	shr	byte ptr [r8 + 4*rax + 291], 123
# CHECK: shr	bl, byte ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0x64,0x18,0xc0,0xac,0x80,0x23,0x01,0x00,0x00,0x7b]
         shr	bl, byte ptr [r8 + 4*rax + 291], 123
# CHECK: {nf}	shr	bl, byte ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0x64,0x1c,0xc0,0xac,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	shr	bl, byte ptr [r8 + 4*rax + 291], 123
# CHECK: {evex}	shr	word ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0x7d,0x08,0xc1,0xac,0x80,0x23,0x01,0x00,0x00,0x7b]
         {evex}	shr	word ptr [r8 + 4*rax + 291], 123
# CHECK: {nf}	shr	word ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0x7d,0x0c,0xc1,0xac,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	shr	word ptr [r8 + 4*rax + 291], 123
# CHECK: shr	dx, word ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0x6d,0x18,0xc1,0xac,0x80,0x23,0x01,0x00,0x00,0x7b]
         shr	dx, word ptr [r8 + 4*rax + 291], 123
# CHECK: {nf}	shr	dx, word ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0x6d,0x1c,0xc1,0xac,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	shr	dx, word ptr [r8 + 4*rax + 291], 123
# CHECK: {evex}	shr	dword ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0xc1,0xac,0x80,0x23,0x01,0x00,0x00,0x7b]
         {evex}	shr	dword ptr [r8 + 4*rax + 291], 123
# CHECK: {nf}	shr	dword ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0xc1,0xac,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	shr	dword ptr [r8 + 4*rax + 291], 123
# CHECK: shr	ecx, dword ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0x74,0x18,0xc1,0xac,0x80,0x23,0x01,0x00,0x00,0x7b]
         shr	ecx, dword ptr [r8 + 4*rax + 291], 123
# CHECK: {nf}	shr	ecx, dword ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0x74,0x1c,0xc1,0xac,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	shr	ecx, dword ptr [r8 + 4*rax + 291], 123
# CHECK: {evex}	shr	qword ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0xc1,0xac,0x80,0x23,0x01,0x00,0x00,0x7b]
         {evex}	shr	qword ptr [r8 + 4*rax + 291], 123
# CHECK: {nf}	shr	qword ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0xc1,0xac,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	shr	qword ptr [r8 + 4*rax + 291], 123
# CHECK: shr	r9, qword ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0xb4,0x18,0xc1,0xac,0x80,0x23,0x01,0x00,0x00,0x7b]
         shr	r9, qword ptr [r8 + 4*rax + 291], 123
# CHECK: {nf}	shr	r9, qword ptr [r8 + 4*rax + 291], 123
# CHECK: encoding: [0x62,0xd4,0xb4,0x1c,0xc1,0xac,0x80,0x23,0x01,0x00,0x00,0x7b]
         {nf}	shr	r9, qword ptr [r8 + 4*rax + 291], 123
# CHECK: {evex}	shr	bl
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0xd0,0xeb]
         {evex}	shr	bl
# CHECK: {nf}	shr	bl
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0xd0,0xeb]
         {nf}	shr	bl
# CHECK: {evex}	shr	bl, cl
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0xd2,0xeb]
         {evex}	shr	bl, cl
# CHECK: {nf}	shr	bl, cl
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0xd2,0xeb]
         {nf}	shr	bl, cl
# CHECK: shr	bl, bl, cl
# CHECK: encoding: [0x62,0xf4,0x64,0x18,0xd2,0xeb]
         shr	bl, bl, cl
# CHECK: {nf}	shr	bl, bl, cl
# CHECK: encoding: [0x62,0xf4,0x64,0x1c,0xd2,0xeb]
         {nf}	shr	bl, bl, cl
# CHECK: {evex}	shr	dx, cl
# CHECK: encoding: [0x62,0xf4,0x7d,0x08,0xd3,0xea]
         {evex}	shr	dx, cl
# CHECK: {nf}	shr	dx, cl
# CHECK: encoding: [0x62,0xf4,0x7d,0x0c,0xd3,0xea]
         {nf}	shr	dx, cl
# CHECK: shr	dx, dx, cl
# CHECK: encoding: [0x62,0xf4,0x6d,0x18,0xd3,0xea]
         shr	dx, dx, cl
# CHECK: {nf}	shr	dx, dx, cl
# CHECK: encoding: [0x62,0xf4,0x6d,0x1c,0xd3,0xea]
         {nf}	shr	dx, dx, cl
# CHECK: {evex}	shr	ecx, cl
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0xd3,0xe9]
         {evex}	shr	ecx, cl
# CHECK: {nf}	shr	ecx, cl
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0xd3,0xe9]
         {nf}	shr	ecx, cl
# CHECK: shr	ecx, ecx, cl
# CHECK: encoding: [0x62,0xf4,0x74,0x18,0xd3,0xe9]
         shr	ecx, ecx, cl
# CHECK: {nf}	shr	ecx, ecx, cl
# CHECK: encoding: [0x62,0xf4,0x74,0x1c,0xd3,0xe9]
         {nf}	shr	ecx, ecx, cl
# CHECK: {evex}	shr	r9, cl
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0xd3,0xe9]
         {evex}	shr	r9, cl
# CHECK: {nf}	shr	r9, cl
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0xd3,0xe9]
         {nf}	shr	r9, cl
# CHECK: shr	r9, r9, cl
# CHECK: encoding: [0x62,0xd4,0xb4,0x18,0xd3,0xe9]
         shr	r9, r9, cl
# CHECK: {nf}	shr	r9, r9, cl
# CHECK: encoding: [0x62,0xd4,0xb4,0x1c,0xd3,0xe9]
         {nf}	shr	r9, r9, cl
# CHECK: {evex}	shr	byte ptr [r8 + 4*rax + 291], cl
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0xd2,0xac,0x80,0x23,0x01,0x00,0x00]
         {evex}	shr	byte ptr [r8 + 4*rax + 291], cl
# CHECK: {nf}	shr	byte ptr [r8 + 4*rax + 291], cl
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0xd2,0xac,0x80,0x23,0x01,0x00,0x00]
         {nf}	shr	byte ptr [r8 + 4*rax + 291], cl
# CHECK: shr	bl, byte ptr [r8 + 4*rax + 291], cl
# CHECK: encoding: [0x62,0xd4,0x64,0x18,0xd2,0xac,0x80,0x23,0x01,0x00,0x00]
         shr	bl, byte ptr [r8 + 4*rax + 291], cl
# CHECK: {nf}	shr	bl, byte ptr [r8 + 4*rax + 291], cl
# CHECK: encoding: [0x62,0xd4,0x64,0x1c,0xd2,0xac,0x80,0x23,0x01,0x00,0x00]
         {nf}	shr	bl, byte ptr [r8 + 4*rax + 291], cl
# CHECK: {evex}	shr	word ptr [r8 + 4*rax + 291], cl
# CHECK: encoding: [0x62,0xd4,0x7d,0x08,0xd3,0xac,0x80,0x23,0x01,0x00,0x00]
         {evex}	shr	word ptr [r8 + 4*rax + 291], cl
# CHECK: {nf}	shr	word ptr [r8 + 4*rax + 291], cl
# CHECK: encoding: [0x62,0xd4,0x7d,0x0c,0xd3,0xac,0x80,0x23,0x01,0x00,0x00]
         {nf}	shr	word ptr [r8 + 4*rax + 291], cl
# CHECK: shr	dx, word ptr [r8 + 4*rax + 291], cl
# CHECK: encoding: [0x62,0xd4,0x6d,0x18,0xd3,0xac,0x80,0x23,0x01,0x00,0x00]
         shr	dx, word ptr [r8 + 4*rax + 291], cl
# CHECK: {nf}	shr	dx, word ptr [r8 + 4*rax + 291], cl
# CHECK: encoding: [0x62,0xd4,0x6d,0x1c,0xd3,0xac,0x80,0x23,0x01,0x00,0x00]
         {nf}	shr	dx, word ptr [r8 + 4*rax + 291], cl
# CHECK: {evex}	shr	dword ptr [r8 + 4*rax + 291], cl
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0xd3,0xac,0x80,0x23,0x01,0x00,0x00]
         {evex}	shr	dword ptr [r8 + 4*rax + 291], cl
# CHECK: {nf}	shr	dword ptr [r8 + 4*rax + 291], cl
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0xd3,0xac,0x80,0x23,0x01,0x00,0x00]
         {nf}	shr	dword ptr [r8 + 4*rax + 291], cl
# CHECK: shr	ecx, dword ptr [r8 + 4*rax + 291], cl
# CHECK: encoding: [0x62,0xd4,0x74,0x18,0xd3,0xac,0x80,0x23,0x01,0x00,0x00]
         shr	ecx, dword ptr [r8 + 4*rax + 291], cl
# CHECK: {nf}	shr	ecx, dword ptr [r8 + 4*rax + 291], cl
# CHECK: encoding: [0x62,0xd4,0x74,0x1c,0xd3,0xac,0x80,0x23,0x01,0x00,0x00]
         {nf}	shr	ecx, dword ptr [r8 + 4*rax + 291], cl
# CHECK: {evex}	shr	qword ptr [r8 + 4*rax + 291], cl
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0xd3,0xac,0x80,0x23,0x01,0x00,0x00]
         {evex}	shr	qword ptr [r8 + 4*rax + 291], cl
# CHECK: {nf}	shr	qword ptr [r8 + 4*rax + 291], cl
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0xd3,0xac,0x80,0x23,0x01,0x00,0x00]
         {nf}	shr	qword ptr [r8 + 4*rax + 291], cl
# CHECK: shr	r9, qword ptr [r8 + 4*rax + 291], cl
# CHECK: encoding: [0x62,0xd4,0xb4,0x18,0xd3,0xac,0x80,0x23,0x01,0x00,0x00]
         shr	r9, qword ptr [r8 + 4*rax + 291], cl
# CHECK: {nf}	shr	r9, qword ptr [r8 + 4*rax + 291], cl
# CHECK: encoding: [0x62,0xd4,0xb4,0x1c,0xd3,0xac,0x80,0x23,0x01,0x00,0x00]
         {nf}	shr	r9, qword ptr [r8 + 4*rax + 291], cl
# CHECK: {evex}	shr	dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x08,0xd1,0xea]
         {evex}	shr	dx
# CHECK: {nf}	shr	dx
# CHECK: encoding: [0x62,0xf4,0x7d,0x0c,0xd1,0xea]
         {nf}	shr	dx
# CHECK: shr	dx, dx
# CHECK: encoding: [0x62,0xf4,0x6d,0x18,0xd1,0xea]
         shr	dx, dx
# CHECK: {nf}	shr	dx, dx
# CHECK: encoding: [0x62,0xf4,0x6d,0x1c,0xd1,0xea]
         {nf}	shr	dx, dx
# CHECK: {evex}	shr	ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x08,0xd1,0xe9]
         {evex}	shr	ecx
# CHECK: {nf}	shr	ecx
# CHECK: encoding: [0x62,0xf4,0x7c,0x0c,0xd1,0xe9]
         {nf}	shr	ecx
# CHECK: shr	ecx, ecx
# CHECK: encoding: [0x62,0xf4,0x74,0x18,0xd1,0xe9]
         shr	ecx, ecx
# CHECK: {nf}	shr	ecx, ecx
# CHECK: encoding: [0x62,0xf4,0x74,0x1c,0xd1,0xe9]
         {nf}	shr	ecx, ecx
# CHECK: {evex}	shr	r9
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0xd1,0xe9]
         {evex}	shr	r9
# CHECK: {nf}	shr	r9
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0xd1,0xe9]
         {nf}	shr	r9
# CHECK: shr	r9, r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x18,0xd1,0xe9]
         shr	r9, r9
# CHECK: {nf}	shr	r9, r9
# CHECK: encoding: [0x62,0xd4,0xb4,0x1c,0xd1,0xe9]
         {nf}	shr	r9, r9
# CHECK: {evex}	shr	byte ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0xd0,0xac,0x80,0x23,0x01,0x00,0x00]
         {evex}	shr	byte ptr [r8 + 4*rax + 291]
# CHECK: {nf}	shr	byte ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0xd0,0xac,0x80,0x23,0x01,0x00,0x00]
         {nf}	shr	byte ptr [r8 + 4*rax + 291]
# CHECK: shr	bl, byte ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x64,0x18,0xd0,0xac,0x80,0x23,0x01,0x00,0x00]
         shr	bl, byte ptr [r8 + 4*rax + 291]
# CHECK: {nf}	shr	bl, byte ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x64,0x1c,0xd0,0xac,0x80,0x23,0x01,0x00,0x00]
         {nf}	shr	bl, byte ptr [r8 + 4*rax + 291]
# CHECK: {evex}	shr	word ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x7d,0x08,0xd1,0xac,0x80,0x23,0x01,0x00,0x00]
         {evex}	shr	word ptr [r8 + 4*rax + 291]
# CHECK: {nf}	shr	word ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x7d,0x0c,0xd1,0xac,0x80,0x23,0x01,0x00,0x00]
         {nf}	shr	word ptr [r8 + 4*rax + 291]
# CHECK: shr	dx, word ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x6d,0x18,0xd1,0xac,0x80,0x23,0x01,0x00,0x00]
         shr	dx, word ptr [r8 + 4*rax + 291]
# CHECK: {nf}	shr	dx, word ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x6d,0x1c,0xd1,0xac,0x80,0x23,0x01,0x00,0x00]
         {nf}	shr	dx, word ptr [r8 + 4*rax + 291]
# CHECK: {evex}	shr	dword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x7c,0x08,0xd1,0xac,0x80,0x23,0x01,0x00,0x00]
         {evex}	shr	dword ptr [r8 + 4*rax + 291]
# CHECK: {nf}	shr	dword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x7c,0x0c,0xd1,0xac,0x80,0x23,0x01,0x00,0x00]
         {nf}	shr	dword ptr [r8 + 4*rax + 291]
# CHECK: shr	ecx, dword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x74,0x18,0xd1,0xac,0x80,0x23,0x01,0x00,0x00]
         shr	ecx, dword ptr [r8 + 4*rax + 291]
# CHECK: {nf}	shr	ecx, dword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0x74,0x1c,0xd1,0xac,0x80,0x23,0x01,0x00,0x00]
         {nf}	shr	ecx, dword ptr [r8 + 4*rax + 291]
# CHECK: {evex}	shr	qword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0xfc,0x08,0xd1,0xac,0x80,0x23,0x01,0x00,0x00]
         {evex}	shr	qword ptr [r8 + 4*rax + 291]
# CHECK: {nf}	shr	qword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0xfc,0x0c,0xd1,0xac,0x80,0x23,0x01,0x00,0x00]
         {nf}	shr	qword ptr [r8 + 4*rax + 291]
# CHECK: shr	r9, qword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0xb4,0x18,0xd1,0xac,0x80,0x23,0x01,0x00,0x00]
         shr	r9, qword ptr [r8 + 4*rax + 291]
# CHECK: {nf}	shr	r9, qword ptr [r8 + 4*rax + 291]
# CHECK: encoding: [0x62,0xd4,0xb4,0x1c,0xd1,0xac,0x80,0x23,0x01,0x00,0x00]
         {nf}	shr	r9, qword ptr [r8 + 4*rax + 291]
